<?php


namespace FiloBlu\Hotfix\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class CleanImages extends Command
{

    protected $_validate_plugin;
    protected $_state;

    public function __construct(
        \FiloBlu\Hotfix\Plugin\Magento\Catalog\Controller\Adminhtml\Product\Validate $validate_plugin,
        \Magento\Framework\App\State $state,
        $name = null
    )
    {
        $this->_validate_plugin = $validate_plugin;
        $this->_state = $state;
        parent::__construct($name);
    }


    /**
     * {@inheritdoc}
     */
    protected function execute(InputInterface $input, OutputInterface $output) {
        $this->ensureAreaCode($output);
        $output->writeln("Please check the logs: ".$this->_validate_plugin->getLogName());
        $this->_validate_plugin->executeImageCleaner();
    }

    /**
     * {@inheritdoc}
     */
    protected function configure()
    {
        $this->setName("filoblu:hotfix:clean-images");
        $this->setDescription("Clean all images tags (small,thumbnail...) if store is not admin");
    }

    protected function ensureAreaCode(OutputInterface $output)
    {
        try {
            $this->_state->setAreaCode(\Magento\Framework\App\Area::AREA_ADMINHTML);
        } catch (\Exception $e) {
            $currentAreaCode = $this->_state->getAreaCode();
            $output->writeln("Area code was already set to {$currentAreaCode}");
        }
    }

}